# Kado
[![Build Status](https://travis-ci.org/KadoOrg/kado.svg?branch=master)](https://travis-ci.org/KadoOrg/kado)
[![npm version](https://badge.fury.io/js/kado.svg)](https://badge.fury.io/js/kado)
[![Join the chat at https://gitter.im/KadoOrg/Lobby](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/KadoOrg/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![FOSSA Status](https://app.fossa.io/api/projects/git%2Bgithub.com%2FKadoOrg%2Fkado.svg?type=shield)](https://app.fossa.io/projects/git%2Bgithub.com%2FKadoOrg%2Fkado?ref=badge_shield)

Web Application System

## Why Kado?

Kado is a consistent curated development environment that aims to empower the
modern developer. All you need is knowledge of HTML, CSS, JavaScript and then
Node.JS helps too. Afterwards you can create stunning web products.

## What is it?

Kado is a development platform that provides the necessary features to build
Web Applications. We consider Node.JS a great interpreter but it expects user
space to bring all functionality which is good for Node.JS, however hard on the
developer. Kado aims to ease that pain by bringing a curated set of features
that make developing in Node.JS much like other first class web languages
such as: PHP, Ruby, Django on Python, etc. 

## Features

* Provides all the needed tools to build websites.
* Removes the hassle of searching NPM for each thing.
* Easy to use and install, most websites need only HTML editing.
* Extensive features and depth for building new modules.
* Does not get in the way of your existing style.
* Speeds up the time needed to get a project started.
* Keeps development across multiple projects consistent.
* Reuse code by introducing a completely modular structure.
* Builds on top of favorite technologies like:
 Node.JS, Express, Sequelize, Mustache, etc
* There are more! See [kado.org](https://kado.org/)

## Demo

Try out Kado locally its really easy to get going especially if you
already develop web applications. See the
[demo installation guide](https://kado.org/content/install-the-demo)

## Usage

Please [see the documentation](https://kado.org/doc/kado/3.x) for more

## Thesis

Take a look at [this thesis document](https://kado.org/content/thesis) for a
more expanded look at why Kado was written and learn about how it will solve
a problem for you or your company.

## Bugs or Issues

Please file an [issue report](https://github.com/KadoOrg/kado/issues)

## Support

Email hello [at] kado.org

or 

[![Join the chat at https://gitter.im/KadoOrg/Lobby](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/KadoOrg/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)

## Changelog

Please see the changelog at [kado.org](https://kado.org/content/changelog)


## License
[![FOSSA Status](https://app.fossa.io/api/projects/git%2Bgithub.com%2FKadoOrg%2Fkado.svg?type=large)](https://app.fossa.io/projects/git%2Bgithub.com%2FKadoOrg%2Fkado?ref=badge_large)